unit Wpscfg32;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, Spin, ExtCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Label1: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn6: TBitBtn;
    OpenDialog1: TOpenDialog;
    Timer1: TTimer;
    SpinEdit1: TSpinEdit;
    Label2: TLabel;
    Timer2: TTimer;
    procedure BitBtn3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer2Timer(Sender: TObject);
    procedure OnAppRestore(Sender: TObject);
  private
    { Private declarations }
    MyIcon: array[0..9] of TIcon;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  DumStr: string;
  MyProfile: string;
  MyConfigFile: string;
  MyInterval: integer;
  MyIndex : integer;
  MyIconIndex: integer;
  WallPaper: array[0..255] of char;
  NextEvent: TDateTime;

implementation

{$R *.DFM}
{$R WPICON32.RES}

uses
  IniFiles;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.OnAppRestore(Sender: TObject);
begin
  Show;
  Application.Restore;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  WindowsDirPChar: array[0..255] of char;
  WindowsDirString: string;
  SearchMask: string;
  SearchRec: TSearchRec;
  SearchNext: boolean;
  MyIni: TIniFile;
begin
  MyIni := TIniFile.Create(MyProfile);
  with MyIni do
  begin
    MyInterval := ReadInteger('General', 'Interval', 30);
    if MyInterval < 10 then
      MyInterval := 10;
    if MyInterval > 3600 then
      MyInterval := 3600;
  end;
  MyIni.Free;
  if FileExists(MyConfigFile) then
  begin
    ListBox1.Items.LoadFromFile(MyConfigFile);
  end
  else
  begin
    GetWindowsDirectory(@WindowsDirPChar[0], 255);
    WindowsDirString := StrPas(@WindowsDirPChar[0]);
    if WindowsDirString <> 'C:\' then
      WindowsDirString := WindowsDirString + '\';
    SearchMask := WindowsDirString + '*.bmp';
    SearchNext := true;
    FindFirst(SearchMask, faAnyFile, SearchRec);
    if SearchRec.Name <> '' then
      ListBox1.Items.Add(WindowsDirString + SearchRec.Name)
    else
      SearchNext := false;
    while SearchNext do
    begin
      if FindNext(SearchRec) = 0 then
        ListBox1.Items.Add(WindowsDirString + SearchRec.Name)
      else
        SearchNext := false;
    end;
  end;
  MyIcon[0]:= TIcon.Create;
  MyIcon[0].Handle := LoadIcon(hInstance, MakeIntResource('ICON1'));
  MyIcon[1]:= TIcon.Create;
  MyIcon[1].Handle := LoadIcon(hInstance, MakeIntResource('ICON2'));
  MyIcon[2]:= TIcon.Create;
  MyIcon[2].Handle := LoadIcon(hInstance, MakeIntResource('ICON3'));
  MyIcon[3]:= TIcon.Create;
  MyIcon[3].Handle := LoadIcon(hInstance, MakeIntResource('ICON4'));
  MyIcon[4]:= TIcon.Create;
  MyIcon[4].Handle := LoadIcon(hInstance, MakeIntResource('ICON1'));
  MyIcon[5]:= TIcon.Create;
  MyIcon[5].Handle := LoadIcon(hInstance, MakeIntResource('ICON6'));
  MyIcon[6]:= TIcon.Create;
  MyIcon[6].Handle := LoadIcon(hInstance, MakeIntResource('ICON7'));
  MyIcon[7]:= TIcon.Create;
  MyIcon[7].Handle := LoadIcon(hInstance, MakeIntResource('ICON8'));
  MyIcon[8]:= TIcon.Create;
  MyIcon[8].Handle := LoadIcon(hInstance, MakeIntResource('ICON9'));
  MyIcon[9]:= TIcon.Create;
  MyIcon[9].Handle := LoadIcon(hInstance, MakeIntResource('ICON10'));
  Application.Icon := MyIcon[1];
  Icon := MyIcon[1];
  MyIndex := 0;
  MyIconIndex := 0;
  Application.ShowMainForm := false;
  Application.OnRestore := OnAppRestore;
  Application.Minimize;
  NextEvent := Now;
end;

procedure TForm1.BitBtn6Click(Sender: TObject);
var
  i: integer;
begin
  for i := (ListBox1.Items.Count - 1) downto 0 do
  begin
    if ListBox1.Selected[i] then
      ListBox1.Items.Delete(i);
  end;
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
var
  i: integer;
  AlreadyThere: boolean;
begin
  if OpenDialog1.Execute then
  begin
    AlreadyThere := false;
    for i := 0 to (ListBox1.Items.Count - 1) do
    begin
      if ListBox1.Items[i] = OpenDialog1.FileName then
        AlreadyThere := true;
    end;
    if not AlreadyThere then
      ListBox1.Items.Add(OpenDialog1.FileName);
  end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  MyIni: TIniFile;
begin
  ListBox1.Items.SaveToFile(MyConfigFile);
  MyInterval := SpinEdit1.Value;
  MyIni := TIniFile.Create(MyProfile);
  with MyIni do
  begin
    WriteInteger('General', 'Interval', MyInterval);
  end;
  MyIni.Free;
  NextEvent := Now;
  Application.Minimize;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  Application.Minimize;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  i, j, k: integer;
begin
  if Now > NextEvent then
  begin
    if (ListBox1.Items.Count > 0) then
    begin
      if MyIndex >= ListBox1.Items.Count then
        MyIndex := 0;
      StrPCopy(@WallPaper[0], ListBox1.Items[MyIndex]);
      SystemParametersInfo(SPI_SetDeskWallPaper, 0, @Wallpaper[0], SPIF_UpdateIniFile);
      inc(MyIndex);
      if MyIndex > (ListBox1.Items.Count - 1) then
        MyIndex := 0;
      k := MyInterval div 3600;
      j := (MyInterval - k) div 60;
      i := MyInterval mod 60;
      NextEvent := Now + EncodeTime(k, j, i, 0);
    end;
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i: integer;
begin
  for i := 0 to 9 do
    MyIcon[i].Free;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
  Application.Icon := MyIcon[MyIconIndex];
  Icon := MyIcon[MyIconIndex];
  inc(MyIconIndex);
  if MyIconIndex > 9 then
    MyIconIndex := 0;
end;

end.
